<template>
    <div class="app-container">
        <!--    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">-->
        <!--      <el-form-item>-->
        <!--        <el-button type="primary" icon="el-icon-search"   @click="handleQuery">搜索</el-button>-->
        <!--        <el-button icon="el-icon-refresh"   @click="resetQuery">重置</el-button>-->
        <!--      </el-form-item>-->
        <!--    </el-form>-->

        <el-row :gutter="10" class="mb8">
            <el-col :span="1.5">
                <el-button type="primary" plain icon="el-icon-plus" @click="handleAdd" v-hasPermi="['activity:couponInfo:add', 'activity:groupInfo:add']">新增</el-button>
            </el-col>
            <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>

        <Page uri="/mapi/activity/couponItem/list" :request-params="queryParams" ref="pagination">
            <el-table-column type="selection" width="55" align="center" fixed="left" />
            <el-table-column label="编号" align="center" prop="id" width="80" />
            <el-table-column label="优惠券名称" align="center" prop="couponTypeTitle" />
            <el-table-column label="优惠券库存" align="center" prop="couponStock" width="120" />
            <el-table-column label="发放数量" align="center" prop="couponSendNum" width="120" />
            <el-table-column label="核销数量" align="center" prop="couponUsedNum" width="120" />
            <!--            <el-table-column label="是否自定义有效期" align="center" prop="isCustomValidityPeriod" width="150">-->
            <!--                <template slot-scope="scope">-->
            <!--                    <dict-tag :options="dict.type.sys_yes_no" :value="scope.row.isCustomValidityPeriod" />-->
            <!--                </template>-->
            <!--            </el-table-column>-->
            <el-table-column label="优惠券有效期开始日期" align="center" prop="startDate" width="180">
                <template slot-scope="scope">
                    <span>{{ parseTime(scope.row.startDate, '{y}-{m}-{d}') }}</span>
                </template>
            </el-table-column>
            <el-table-column label="优惠券有效期结束日期" align="center" prop="endDate" width="180">
                <template slot-scope="scope">
                    <span>{{ parseTime(scope.row.endDate, '{y}-{m}-{d}') }}</span>
                </template>
            </el-table-column>
            <el-table-column label="操作" align="center" class-name="small-padding fixed-width" fixed="right">
                <template slot-scope="scope">
                    <el-button type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)" v-hasPermi="['activity:couponInfo:edit', 'activity:groupInfo:edit']">修改</el-button>
                    <el-button type="text" icon="el-icon-plus" @click="handleAddCoupon(scope.row)" v-hasPermi="['activity:couponInfo:edit', 'activity:groupInfo:edit']">添加库存</el-button>
                    <el-button type="text" icon="el-icon-minus" @click="handleMinuteCoupon(scope.row)" v-hasPermi="['activity:couponInfo:edit', 'activity:groupInfo:edit']">减少库存</el-button>
                    <el-button type="text" icon="el-icon-delete" @click="handleDelete(scope.row)" v-hasPermi="['activity:couponInfo:remove', 'activity:groupInfo:remove']">删除</el-button>
                </template>
            </el-table-column>
        </Page>

        <!-- 添加或修改注册送券活动优惠券明细对话框 -->
        <el-dialog :title="title" :visible.sync="open" size="30%" append-to-body>
            <el-row :gutter="15">
                <el-form ref="form" :model="form" :rules="rules" label-width="180px">
                    <el-col :span="24">
                        <el-form-item label="选择优惠券" prop="couponTypeId">
                            <el-select v-model="form.couponTypeId" placeholder="请选择优惠券" :style="{ width: '100%' }" :disabled="form.id != null">
                                <el-option v-for="item in couponTypes" :label="item.title" :value="item.id" :key="item.title"> </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                    <el-col :span="24">
                        <el-form-item label="设置库存" prop="couponStock">
                            <el-input-number v-model="form.couponStock" placeholder="请输入优惠券库存" :disabled="form.id != null" :precision="0" :min="1" :max="999999" />
                        </el-form-item>
                        <el-form-item label="是否自定义有效期" prop="isCustomValidityPeriod">
                            <el-radio-group v-model="form.isCustomValidityPeriod">
                                <el-radio-button v-for="dict in dict.type.sys_yes_no" :key="dict.value" :label="dict.value">{{ dict.label }}</el-radio-button>
                            </el-radio-group>
                        </el-form-item>
                        <el-form-item label="有效期" prop="duringDate" v-if="form.isCustomValidityPeriod == 'Y'">
                            <el-date-picker v-model="form.duringDate" style="width: 240px" value-format="yyyy-MM-dd" type="daterange" range-separator="-" start-placeholder="开始日期" end-placeholder="结束日期"></el-date-picker>
                        </el-form-item>
                    </el-col>
                </el-form>
            </el-row>

            <div slot="footer" class="dialog-footer">
                <el-button type="primary" @click="submitForm" style="margin-left: 5%">提交</el-button>
                <el-button @click="cancel">取 消</el-button>
            </div>
        </el-dialog>

        <el-dialog :title="stockTitle" :visible.sync="stockOpen" width="500px" append-to-body>
            <el-form ref="stockForm" :model="stockForm" :rules="stockRoles" label-width="180px">
                <el-form-item :label="stockTitle + '数量'" prop="stockNum">
                    <el-input-number v-model="stockForm.stockNum" placeholder="请输入库存数量" :min="0" />
                </el-form-item>
            </el-form>
            <div slot="footer" class="dialog-footer">
                <el-button type="primary" @click="submitStockForm">确 定</el-button>
                <el-button @click="cancelStock">取 消</el-button>
            </div>
        </el-dialog>
    </div>
</template>

<script>
import { listCouponItem, getCouponItem, delCouponItem, addCouponItem, updateCouponItem, editStock } from '@/api/activity/couponItem'
import { allList } from '@/api/coupon/type'

export default {
    name: 'CouponItem',
    dicts: ['sys_yes_no'],
    data() {
        return {
            stockTitle: '',
            stockOpen: false,
            activityCouponItemId: null,
            stockForm: {},
            // 遮罩层
            loading: true,
            // 选中数组
            ids: [],
            // 非单个禁用
            single: true,
            // 非多个禁用
            multiple: true,
            // 显示搜索条件
            showSearch: true,
            // 总条数
            total: 0,
            // 注册送券活动优惠券明细表格数据
            couponItemList: [],
            // 弹出层标题
            title: '',
            // 是否显示弹出层
            open: false,
            // 查询参数
            queryParams: {},
            // 表单参数
            form: {
                isCustomValidityPeriod: 'N'
            },
            // 表单校验
            rules: {
                couponTypeId: [{ required: true, message: '优惠券类型ID不能为空', trigger: 'change' }],
                couponStock: [{ required: true, message: '优惠券库存不能为空', trigger: 'blur' }],
                isCustomValidityPeriod: [{ required: true, message: '是否自定义有效期不能为空', trigger: 'blur' }],
                duringDate: [{ required: true, message: '优惠券有效期不能为空', trigger: 'blur' }]
            },
            stockRoles: {
                stockNum: [{ required: true, message: '库存数量不能为空', trigger: 'blur' }]
            },
            couponTypes: []
        }
    },
    created() {
        this.activityId = this.$route.params && this.$route.params.activityId
        allList(2).then((res) => {
            this.couponTypes = res.data
            console.log('couponTypes', this.couponTypes)
        })
        this.getList()
    },
    methods: {
        /** 查询注册送券活动优惠券明细列表 */
        getList() {
            this.queryParams.activityId = this.activityId
            this.$nextTick(() => {
                this.$refs.pagination.handleSearch(true)
            })
        },
        // 取消按钮
        cancel() {
            this.open = false
            this.reset()
        },
        cancelStock() {
            this.stockOpen = false
            this.stockReset()
        },
        stockReset() {
            this.stockForm = {
                stockNum: null
            }
            this.resetForm('stockForm')
        },
        // 表单重置
        reset() {
            this.form = {
                id: null,
                activityId: null,
                couponTypeId: null,
                couponStock: null,
                isCustomValidityPeriod: 'N',
                startDate: null,
                endDate: null,
                duringDate: null,
                createById: null,
                createBy: null,
                createTime: null,
                updateById: null,
                updateBy: null,
                updateTime: null,
                remark: null,
                delFlag: null
            }
            this.resetForm('form')
        },
        /** 搜索按钮操作 */
        handleQuery() {
            this.getList()
        },
        /** 重置按钮操作 */
        resetQuery() {
            this.resetForm('queryForm')
            this.handleQuery()
        },
        // 多选框选中数据
        handleSelectionChange(selection) {
            this.ids = selection.map((item) => item.id)
            this.single = selection.length !== 1
            this.multiple = !selection.length
        },
        /** 新增按钮操作 */
        handleAdd() {
            this.reset()
            this.open = true
            this.title = '添加注册送券活动优惠券明细'
        },
        /** 修改按钮操作 */
        handleUpdate(row) {
            this.reset()
            const id = row.id
            getCouponItem(id).then((response) => {
                if (response.data.isCustomValidityPeriod == 'Y') {
                    var duringDate = []
                    duringDate.push(response.data.startDate)
                    duringDate.push(response.data.endDate)
                    response.data.duringDate = duringDate
                }
                this.form = response.data
                this.open = true
                this.title = '修改注册送券活动优惠券明细'
            })
        },
        /** 提交按钮 */
        submitForm() {
            if (null != this.form.duringDate && this.form.duringDate.length > 0) {
                this.form['startDate'] = this.form.duringDate[0]
                this.form['endDate'] = this.form.duringDate[1]
            } else {
                delete this.form.startDate
                delete this.form.endDate
            }
            this.$refs['form'].validate((valid) => {
                if (valid) {
                    if (this.form.id != null) {
                        updateCouponItem({ ...this.form, ...{ activityId: this.activityId } }).then((response) => {
                            this.$modal.msgSuccess('修改成功')
                            this.open = false
                            this.getList()
                        })
                    } else {
                        addCouponItem({ ...this.form, ...{ activityId: this.activityId } }).then((response) => {
                            this.$modal.msgSuccess('新增成功')
                            this.open = false
                            this.getList()
                        })
                    }
                }
            })
        },
        /** 删除按钮操作 */
        handleDelete(row) {
            const ids = row.id || this.ids
            this.$modal
                .confirm('是否确认删除注册送券活动优惠券明细编号为"' + ids + '"的数据项？')
                .then(function () {
                    return delCouponItem(ids)
                })
                .then(() => {
                    this.getList()
                    this.$modal.msgSuccess('删除成功')
                })
                .catch(() => {})
        },
        /** 导出按钮操作 */
        handleExport() {
            this.download(
                'mapi/activity/couponItem/export',
                {
                    ...this.queryParams
                },
                `couponItem_${new Date().getTime()}.xlsx`
            )
        },
        checkClose(done) {
            this.$confirm('是否关闭表单，关闭后数据将丢失？')
                .then(function () {
                    done()
                })
                .then(() => {})
                .catch(() => {})
        },
        handleAddCoupon(row) {
            this.stockTitle = '添加库存'
            this.stockOpen = true
            this.activityCouponItemId = row.id
            this.stockReset()
        },
        handleMinuteCoupon(row) {
            this.stockTitle = '减少库存'
            this.stockOpen = true
            this.activityCouponItemId = row.id
            this.stockReset()
        },
        submitStockForm() {
            this.$refs['stockForm'].validate((valid) => {
                if (valid) {
                    editStock({ ...{ isAdd: this.stockTitle == '添加库存' ? 'Y' : 'N', activityCouponItemId: this.activityCouponItemId }, ...this.stockForm }).then((res) => {
                        this.$modal.msgSuccess('提交成功')
                        this.stockOpen = false
                        this.getList()
                    })
                }
            })
        }
    }
}
</script>
